#!/usr/bin/env Python
#coding=utf-8
import json
import os
import pdb
import codecs

packageName = ''   #包名
className = ''	   #类名称
messageID = ''	   #messageId
description =''    #功能描述
serverproto = {}
clientproto = {}
publickproto = {}
comments= ''  

#获得messageId 字符串
def getMessageIDString(line):
	global messageID
	#pdb.set_trace()
	if line.find('CMsgId') != -1 or line.find('SMsgId') != -1:
		messageID = line.replace('\r\n','').replace('\n','')
		
#获得description 字符串
def getdescriptionString(line):
	global description
	if  line.startswith('//') and line.find('CMsgId') == -1 and line.find('SMsgId') == -1:
		description = line.replace('\r\n','').replace('\n','')
		

#解析消息ID
def getMessageID(line):
	global messageID
	global serverproto 
	global clientproto
	global publickproto
	
	#pdb.set_trace() 
	cMsgIdIndex  = messageID.find('CMsgId')
	sMsgIdIndex = messageID.find('SMsgId')

	if(messageID == "" or (cMsgIdIndex == -1 and sMsgIdIndex == -1)):
		protoClassName  = packageName + '.' + className;
		publickproto[className]  = protoClassName
		return
	
	if(cMsgIdIndex == -1):
		getProtoMessage(serverproto,messageID)
	elif(sMsgIdIndex == -1):
		getProtoMessage(clientproto,messageID)
	else:
		maxIndex = max( sMsgIdIndex,cMsgIdIndex)
		line1 = messageID[0:maxIndex];
		line2 = messageID[maxIndex:];
		if(line1.find('CMsgId') != -1):
			getProtoMessage(clientproto,line1)
			getProtoMessage(serverproto,line2)
		else:
			getProtoMessage(clientproto,line2)
			getProtoMessage(serverproto,line1)
				
def getProtoMessage(proto,line):
	global Publicproto
	messageList = line.split(',')
	for message in messageList:
		messageIdArray = message.split('-')
		if len(messageIdArray) < 2:
			break
		mainId = filter(str.isdigit, messageIdArray[0])
		subId = filter(str.isdigit, messageIdArray[1])

		protoClassName  = packageName + '.' + className;
	
		if mainId:
			if str(mainId) not in proto:
				proto[str(mainId)] = {}
			proto[str(mainId)][str(subId)]  = protoClassName
		else:
			proto[className]  = protoClassName


#保存
def write(filePath,OpenFlag,data,isJson):
	saveData = data 
	if isJson is True:
		saveData=json.dumps(data,sort_keys=True, indent=2)
	with open(filePath, OpenFlag) as json_file:
		json_file.write(saveData)

#解析package名称		
def getPageageName(line):
	global packageName
	if line.startswith('package'):
		packageName = line.replace('package','').replace(';','').strip()
		
#解析类名称		
def getClassName(line):
	global className
	if line.startswith('message'):
		className = line.replace('message','').replace('{','').strip()

#解析message结构		
def analysisMessage(line):
	global description
	global className
	global comments
	global messageID
	if line.startswith('message'):
		getClassName(line)
		
		getMessageID(line)
		
		tenDescript = description.replace('description:','').strip()
		
		#添加注释
		format = "%s -- %s\n" 
		values = (tenDescript, className)
		comment = format % values
		if comment.find('//') == -1:
			comments += '//'
		comments += comment
		messageID = ''
		description = ''	
	
		
#读取proto文件	
def readProtoFile(filePath,outPutPath,outPutFileName):
	file = open(filePath)
	line = file.readline()
	global serverproto 	#服务端发送
	global clientproto 	#客户端发送
	global publickproto
	global comments #注释
	descript = line
	global messageID
	global packageName
	global className
	global description
	#初始化
	packageName = ''   #包名
	className = ''	   #类名称
	messageID = ''	   #messageId
	description =''    #功能描述
	serverproto = {}
	clientproto = {}
	publickproto = {}
	comments= ''  
	
	while line:	
		#解析package名称
		if line[:3]==codecs.BOM_UTF8:
			line=line[3:]
		getPageageName(line)
		
		#获得messageId 字符串
		getMessageIDString(line)
		
		#获得description 字符串
		getdescriptionString(line)
	
		#解析message结构	
		analysisMessage(line)
			
		descript = messageID.replace('\r\n','').replace('\n','')
		line = file.readline()

	encodeComment = comments
	write(outPutPath,'w',encodeComment,False)
	
	format = "var %s = " 
	
	outValue  =  format % outPutFileName
	write(outPutPath,'a',outValue,False)
	
	
	protoObj = {};
	protoObj['server'] = serverproto;
	protoObj['client'] = clientproto;
	protoObj['protoName'] = publickproto;
	write(outPutPath,'a',protoObj,True)
	
	



#列出文件夹下所有的proto文件
protodir = './'			#proto 文件目录
outPutdir = './'				#输出目录
list = os.listdir(protodir)
for i in range(0,len(list)):
	if list[i].find('.proto') == -1:
		continue
	path = os.path.join(protodir,list[i])
	outPutFileName = list[i].replace('Message.proto','ProtoName').replace('Msg.proto','ProtoName') + '.js';
	outPutPath = os.path.join(outPutdir,outPutFileName)
	FileName = list[i].replace('Message.proto','ProtoName').replace('Msg.proto','ProtoName')
	readProtoFile(path,outPutPath,FileName)

	
		


